//
//  DCDebugAction.h
//  Debug-Controller
//
//  Created by Tom Susel on 2/5/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface DCDebugAction : NSObject {
	NSString		*_title;
	NSInvocation	*_invocation;
}

/**
 Title to display at the controller UI.
 */
@property (nonatomic, copy) NSString		*title;

/**
 The operation that would be performed when this action is chosen.
 */
@property (nonatomic, retain) NSInvocation	*invocation;

/**
 Initiator.
 @returns An DCDebugAction instance.
 */
- (id)initWithTitle:(NSString*)aTitle
		 invocation:(NSInvocation*)anInvocation;

/**
 Comfort initiator.
 Creates the invocation object and calls initWithTitle:invocation: initiator.
 */
- (id)initWithTitle:(NSString*)aTitle
			 target:(id)target
		   selector:(SEL)aSelector
			 object:(NSObject*)anObject;


@end
