//
//  DCDebugAction.m
//  Debug-Controller
//
//  Created by Tom Susel on 2/5/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "DCDebugAction.h"


@implementation DCDebugAction
@synthesize title = _title, invocation = _invocation;

#pragma mark -
#pragma mark NSObject

- (void)dealloc{
	self.title = nil;
	self.invocation = nil;
	[super dealloc];
}

#pragma mark -
#pragma mark DCDebugAction - public

- (id)initWithTitle:(NSString*)aTitle
		 invocation:(NSInvocation*)anInvocation{
	if (self = [super init]){
		self.title = aTitle;
		self.invocation = anInvocation;
	}
	
	return self;
}

- (id)initWithTitle:(NSString*)aTitle
			 target:(id)target
		   selector:(SEL)aSelector
			 object:(NSObject*)anObject{
	
	NSInvocationOperation *invocationOperation = [[NSInvocationOperation alloc] initWithTarget:target
																					  selector:aSelector
																						object:anObject];
	
	if (self = [self initWithTitle:aTitle
						invocation:invocationOperation.invocation]){
		
	}
	
	[invocationOperation release];
	
	return self;
}

#pragma mark -
#pragma mark DCDebugAction - private

@end
