//
//  DCManager.h
//  Debug-Controller
//
//  Created by Tom Susel on 2/5/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "DCDebugAction.h"
#import "DCViewController.h"
#import "DCShakeRecognizer.h"

@interface DCManager : NSObject {
	NSMutableArray		*_debugActions;
	DCViewController	*_viewController;
	DCShakeRecognizer	*_shakeRecognizer;
}

@property (nonatomic, readonly) NSMutableArray *debugActions;

/**
 Initiates and returns the singleton instance.
 */
+ (DCManager*)sharedInstance;

/**
 Adds an action to the actions array.
 */
- (void)addAction:(DCDebugAction*)debugAction;

/**
 Comfort addition method.
 Creates the debug action for you.
 */
- (void)addActionWithTitle:(NSString*)title
					target:(id)target
				  selector:(SEL)aSelector
					object:(NSObject*)anObject;


/**
 Shows the debug controller UI.
 */
- (void)showController;

/**
 Hides the debug controller UI.
 */
- (void)hideController;

/**
 If controller is visible hides it, otherwise shows it.
 */
- (void)toggleController;


@end
