    //
//  DCViewController.m
//  Debug-Controller
//
//  Created by Tom Susel on 2/5/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "DCViewController.h"
#import "DCDebugAction.h"
#import "DCManager.h"

#define kDCViewControllerHeight	300.0
#define kDCViewControllerWidth	250.0
#define kDCViewControllerHPad 3.0
#define kDCViewControllerVPad 3.0

@implementation DCViewController

// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {

		self.view = [[UIView alloc] initWithFrame:CGRectMake(0.0, 0.0, kDCViewControllerWidth, kDCViewControllerHeight)];
		self.view.backgroundColor = [UIColor greenColor];
		_tableView = [[UITableView alloc] initWithFrame:CGRectMake(kDCViewControllerHPad,
																   kDCViewControllerVPad, 
																   kDCViewControllerWidth - 2.0 * kDCViewControllerHPad,
																   kDCViewControllerHeight -2.0 * kDCViewControllerVPad)
												  style:UITableViewStyleGrouped];
		_tableView.delegate = self;
		_tableView.dataSource = self;
		[self.view addSubview:_tableView];
    }
    return self;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations.
	return YES;
	
}


- (void)didReceiveMemoryWarning {
	//Avoid memory management for debug purposes.
}

- (void)viewDidUnload {
	//Avoid memory management for debug purposes.
}


- (void)dealloc {
    [super dealloc];
}

#pragma mark -
#pragma mark UITableViewDelegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
	[tableView deselectRowAtIndexPath:indexPath animated:YES];
	
	if (indexPath.row == [[[DCManager sharedInstance] debugActions] count]){
		//Last row
		
		[[DCManager sharedInstance] hideController];
	}
	else {
		//Not last row
		
		DCDebugAction *debugAction = [[[DCManager sharedInstance] debugActions] objectAtIndex:indexPath.row];
		
		NSInvocationOperation *invocationOperation = [[NSInvocationOperation alloc] initWithInvocation:debugAction.invocation];
		[invocationOperation start];
		[invocationOperation release];
	}
}

#pragma mark -
#pragma mark UITableViewDataSource

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
	return [[DCManager sharedInstance].debugActions count] + 1;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
	static NSString *cellId = @"cellId";
	
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellId];
	
	if (cell == nil){
		cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault
									   reuseIdentifier:cellId] autorelease];
		cell.textLabel.textAlignment = UITextAlignmentCenter;
		
	}
	
	if (indexPath.row == [[[DCManager sharedInstance] debugActions] count]){
		//Last row
		cell.textLabel.text = @"Close";
	}
	else {
		//Not last row
		DCDebugAction *debugAction = [[[DCManager sharedInstance] debugActions] objectAtIndex:indexPath.row];

		cell.textLabel.text = debugAction.title;
	}

	
	return cell;
}



@end
